#pragma once
#include "Entity.h"
#include "stdafx.h"

enum ControllerActions {
	forward,
	backward,
	turnLeft,
	turnRight,
	changeCamera,

	dropUnit,
	reload,

	slower,
	faster
};

const std::string actionsStr[] = {
	"accelerate",
	"brake",
	"left",
	"right",
	"camera",
	"shoot",
	"restart",
	"",
	""
};

class Controller {
protected:
	bool* actions;
	SDLKey* controllerKeys;
	int nControllerKeys;

	std::string getActionString(int action);
	int getActionFromString(std::string& str);
public:
	Controller(void);
	~Controller(void);
	void loadControls(Json::Value& node);
	void pollEvent(SDL_Event* event);
	bool isDown(ControllerActions action);
	bool isPressed(ControllerActions action);
	void dumpJSON(void);
};
