#pragma once
#include "World.h"
#include "Camera.h"
#include "Terrain.h"
#include "Controller.h"
#include "Player.h"
#include "Skybox.h"
#include "HUD.h"
#include "Scene.h"
#include <list>



class GameWorld :
	public World
{
protected:
	Scene scene;

	HUD hud;
	HUDData data;

	Player player;
	bool firstPerson;

	std::string curWorldFile;
	
	virtual void spawnUnit(Unit& spwaner);

	void parseModel(Json::Value& modelNode, ModelEntity& entity);
	void parseCheckpoints(Json::Value& checkpNode);
	void parseScenery(Json::Value& sceneryNode);

public:
	Controller control;

	Terrain terrain;
	unsigned int nCheckpoints;
	ModelEntity* checkpoints;

	unsigned int nScenery;
	ModelEntity* scenery;

	std::list<Unit*> units;

	GameWorld(void);

	virtual void setup(void);
	virtual void cleanup(void);

	virtual void loadWorld(const std::string& worldFile);
	virtual void clearWorld(void);
	virtual void reloadWorld(void);

	virtual void pollEvent(SDL_Event* e);
	virtual void processInput(float dt);
	virtual void processLogic(float dt);
	virtual void renderScene(void);
};

