#include "NetClientWorld.h"

extern Config cfg;
extern SurfaceManager surfaceManager;

void NetClientWorld::setup() {
	GameWorld::setup();
	connectSurf = surfaceManager.getSurface("connecting.png");
	connectSurf.sy = 0.5f;
	connectSurf.x = 0.5f;
	connectSurf.y = 0.5f;
}

void NetClientWorld::processInput(float dt) {
	
}

void NetClientWorld::processLogic(float dt) {
	
}

void NetClientWorld::renderScene(void) {
	if (connected && curWorldFile != "") {
		GameWorld::renderScene();
	} else {
		renderConnecting();
	}
}

void NetClientWorld::renderConnecting(void) {
	SurfEffect lastEffect = connectSurf.lastAnimation.effect;
	if (!connectSurf.animating) {
		if (lastEffect == FADE_IN) {
			connectSurf.fadeOut(2000);
		} else {
			connectSurf.fadeIn(1000);
		}
	}

	if (cfg.screenW > cfg.screenH) {
		glViewport((cfg.screenW - cfg.screenH) / 2, 0, cfg.screenH, cfg.screenH);
	} else {
		glViewport(0, (cfg.screenH - cfg.screenW) / 2, cfg.screenW, cfg.screenW);
	}
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	
	connectSurf.render();
	SDL_GL_SwapBuffers();
}

bool NetClientWorld::reconnect() {
	if (!socket.open(0)) {
		connected = false;
		return false;
	}

	char nick[254] = "player";
	NetCommand cmd(CONNECT,nick, sizeof(nick));
	
	socket.send(curAddr, cmd.getData(), cmd.getDataSize());
	
	// FIXME: check if server sends ack
	connected = true;
	return true;
}

bool NetClientWorld::connectTo(NetAddress addr) {
	curAddr = addr;
	return reconnect();
}

void NetClientWorld::pollEvent(SDL_Event* e) {
	if ( e->type == SDL_QUIT || 
		(e->type == SDL_KEYDOWN 
			&& e->key.keysym.sym == SDLK_ESCAPE)) {
		running = false;
	}

	netControl.pollEvent(e);
}

