#pragma once
#include "GameWorld.h"
#include "NetSocket.h"
#include "NetController.h"
#include "NetCommand.h"

#include "SurfaceManager.h"
#include "GLSurface.h"

#define CONNECT_PORT 9666

class NetClientWorld :
	public GameWorld {

protected:
	NetSocket socket;
	NetAddress curAddr;
	NetController netControl;
	GLSurface connectSurf;
	bool connected;

	void renderConnecting(void);
public:
	virtual void setup(void);
	virtual void pollEvent(SDL_Event* e);

	virtual void processInput(float dt);
	virtual void processLogic(float dt);
	virtual void renderScene(void);

	bool reconnect();
	bool connectTo(NetAddress addr);
};

