#include "NetServerWorld.h"

NetServerWorld::NetServerWorld(void)
{
}


void NetServerWorld::processLogic(float dt) {
	recvLoop();
	GameWorld::processLogic(dt);
}

void NetServerWorld::recvLoop(void) {
	NetAddress addr;
	char data[256];
	
	data[0] = 0;
	sock.receive(addr, (void*)data, 256);

	if (addr.getAddress() != 0 || data[0] != 0) {
		d("[%d.%d.%d.%d]>> '%s'\n", addr.getA(),addr.getB(),addr.getC(),addr.getD(), data);
	}
}

void NetServerWorld::startListen(void) {
	if (!sock.open(LISTEN_PORT)) d("couldn't open listen socket\n","");
	if (!sock.setNonblock(true)) d("couldn't set to nonblocking\n","");
}

void NetServerWorld::pollEvent(SDL_Event* e) {
	if (e && (e->type == SDL_QUIT || 
		(e->type == SDL_KEYDOWN 
			&& e->key.keysym.sym == SDLK_ESCAPE))) {
		running = false;
	}
}

void NetServerWorld::loadWorld(std::string& world) {
	GameWorld::loadWorld(world);
	startListen();
}

void NetServerWorld::parseCommand(NetCommand& cmd) {
	
}

void NetServerWorld::processInput(float dt) {
	NetAddress recvAddr;
	char data[256];
	
	pollEvent(NULL);

	int size = sock.receive(recvAddr, data, sizeof(data));
	if (size > 0) {
		NetCommand cmd(data, size);
		d("%d: %s\n", cmd.getCommand(), cmd.getData());
	}

}

void NetServerWorld::renderScene() {
	GameWorld::renderScene();
}
