#pragma once
#include "World.h"
#include "GLSurface.h"
#include "GameWorld.h"
#include "Player.h"
#include "Scene.h"
#include "Controller.h"
#include "config.h"
#include "SurfaceManager.h"

#define RADIUS 20.0f

class PlayerSelect :
	public World
{
protected:

	Scene scene;
	GLSurface surf;
	GameWorld* nextWorld;
	std::string gameWorld;

	std::vector<Player> players;

	Controller control;
	int curPlayer;

	float rotation;

	virtual void loadPlayerList(void);
	virtual void setupPlayers(void);
	
public:
	PlayerSelect(std::string startMap);
	virtual void setup(void);
	virtual void pollEvent(SDL_Event* e);
	virtual void processInput(float dt);
	virtual void renderScene(void);
};

